
\chapter{ Taking Data \label{ch:take-data} } 

We recorded video frames using the uEye camera connected to the computer. The software to capture images from the camera came with the uEye software package, but it lacked a ``Save'' button, which we added. Our executable may be downloaded in a ZIP archive from: \\

\archiveBaseURL\url{/t17/uEye-Sequencer-x64bin.zip} \\

\noindent The source code may be downloaded from: \\

\archiveBaseURL\url{/t17/uEye-Sequencer-Source.zip} \\

The instructions how to use this may be found at the end of this chapter. \\

\begin{figure}[h] 
	\begin{center} 
		\includegraphics[width=6in]{Figures/April-6/uEyeSequence-ruvim.png} 
	\end{center} 
	\caption{ We added a ``Save'' button to the uEye Sequencer sample program's source code, and we used that to capture images from the camera. \label{scr:apr6:uEye-seq} } 
\end{figure} 

The IDS uEye software package had sample programs, and luckily, the source code was there too. The uEye Sequencer sample program was suitable because it captures image sequences into memory, without compression, in their original quality. It did not come with a ``save images'' button, so we went into the source code and added a ``save'' button. After compiling it with Visual Studio, we were able to capture 1250 frames (25 seconds) at a time, and then save them as bitmap (BMP) sequences in their own folders. The user interface, with the button we added, are shown in \fig{scr:apr6:uEye-seq}. \\

\begin{figure}[h] 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/frame0001.png} 
		\caption{ Setup-1 \label{frame:apr3:s-1-raw} } 
	\end{subfigure} 
	\begin{subfigure}[b]{0.5\textwidth} 
		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/frame0001.png} 
		\caption{ Setup-3 \label{frame:apr3:s-3-raw} } 
	\end{subfigure} 
	\caption{ The first frame captured for each setup. \label{frame:apr3:raw} } 
\end{figure} 

The maximum of frames that could fit in memory on the computer was around 1400 or so, but 1400 is 28 seconds, which is not as much of a round number as 25 seconds. The camera's default framerate is 50 frames per second, and the number of frames to capture was the only user-editable option that came with uEye Sequencer. The rest of the settings were loaded from the camera driver's defaults. Even though we were unable to change any other parameters, we were okay because it made sense to just use those parameters loaded from the camera; those parameters are what the camera was designed to perform best with. The image resolution was 1280 by 1024 pixels. We used the ``Y8 monochrome'' color parameter, which meant the bit depth was 8 bits. We captured 1250 frames at a time. The LED light grid was turned up to be bright, but not as bright as to saturate the pixels. \fig{frame:apr3:raw} shows the first frame captured from each setup's recorded image sequence. \\

%\begin{figure}[h] 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-01/stat_min.png} 
%		\caption{ Setup-1 \label{frame:apr3:s-1-min} } 
%	\end{subfigure} 
%	\begin{subfigure}[b]{0.5\textwidth} 
%		\includegraphics[width=\linewidth]{Figures/April-3/Setup-03-b/stat_min.png} 
%		\caption{ Setup-3 \label{frame:apr3:s-3-min} } 
%	\end{subfigure} 
%	\caption{ The statistical minimum over all the frames by setup. \label{frame:apr3:min} } 
%\end{figure} 



To use the uEye Sequencer, perform the following after opening it: 

\begin{enumerate} 
	\item There is a ``Realloc Buffers'' button near the bottom third of the controls. In the number input box next to it, change the number to the desired number of frames (for example, 1250). Push the ``Realloc Buffers'' button. 
	\item To continuously ``preview'' what's on camera, ensure the ``Ring Buffer'' radio button at the very top is checked, and click ``Capture.'' 
	\item To record a set of frames, ensure ``Linear Buffer'' is selected and click ``Capture.'' 
	\item After recording stops, click the ``Save'' button. In the dialog that opens, browse to a new folder where the image sequence should be saved. Type the filename for frame 1 (for example, type ``frame0001''), and click ``Save.'' 
\end{enumerate} 



